import { Serde } from '../decorator'
import { Constructor, staticImplements } from '../utils'
import { GenericVisitor } from './generic'
import { Deserialize, Deserializer } from './interface'

export function deserialize<T, C extends Constructor>(constructor: C) {
  @staticImplements<Deserialize<T>>()
  class Deserializable extends constructor {
    static deserialize<D extends Deserializer>(deserializer: D): T {
      const visitor = new GenericVisitor<T>()
      return deserializer.deserializeAny(visitor)
    }
  }
  Deserializable[Serde] = (constructor as any)[Serde]

  return Deserializable
}

